moDraw.iconPreviewPDA = {};

function moDraw.iconPreviewPDA:setOpen(self)
	local whichSubPDA = "";
	if MultiOverlayV3.guiMenue.on ~= nil and MultiOverlayV3.guiMenue.on and g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then		
		if moSetGetOverlays.iconPreviewPDA.iconOverlay == nil or #moSetGetOverlays.iconPreviewPDA.iconOverlay <= 0 then moSetGetOverlays:loadIconOverlaysForPreviewPDA(self);end;
		--posX,posY,width,height,center, {setSettingsButton=0,setSaveButton=0,setCloseButton=0,setZoomButton=0,setDragDropButton=0,setUpDownButton=0,setLeftRightButton=0}; --0= Off, 1= On, 2= On is Mouse Ready
		local upDownButton = 2;
		if #moSetGetOverlays.iconPreviewPDA.iconOverlay <= 150 then upDownButton = 0;end;
		local iconClickTable = moDraw.simpleAppPDA:setOpenDraw(self, "PDA Preview Icons", moSetGetOverlays.iconPreviewPDA.overlay, 0.37, 0.65, 15, 11, nil, {0,0,2,0,0,upDownButton,0});
		moGeneralSettings.clickAreas.previewIcons = {};		
		local pdaOverlays = moSetGetOverlays.iconPreviewPDA.overlay;
		local distanceAppIcons = pdaOverlays.viewOtherValues.distanceAppIcons or 1;
		local zoomLevel = pdaOverlays.viewOtherValues.zoomLevel or moSetGetOverlays.defaultZoomOutInTemp;		
		local distanceAppIconWidth = (pdaOverlays[5].width-(moSetGetOverlays.buttonGfxWidth1*moSetGetOverlays.defaultZoomOutInTemp*((zoomLevel*1.5)+distanceAppIcons)))/2;
		local distanceAppIconHeight = (pdaOverlays[5].height-(moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.defaultZoomOutInTemp*((zoomLevel*1.5)+distanceAppIcons)))/2;
		local optiSize = moSetGetExtras:optiHeightSize(self, pdaOverlays[1].height-(0.001), tostring("PDA Preview Icons"), 0.0105);
		setTextColor(1, 1, 1, 1);
		setTextBold(true);
		renderText(pdaOverlays[1].x+pdaOverlays[1].width, pdaOverlays[1].y+(0.001), optiSize, tostring("PDA Preview Icons Side ").. tostring(moSetGetOverlays.iconPreviewPDA.bounds[3]));
		setTextBold(false);		
		local viewIcons = moSetGetOverlays.iconPreviewPDA.bounds[1];		
		if iconClickTable ~= nil then
			for a=1, #iconClickTable do
				if iconClickTable[a].whereClick == "PDA Preview Icons" then
					if iconClickTable[a].whatClick == "appPdaLinePos" then						
						if moSetGetOverlays.iconPreviewPDA.iconOverlay[viewIcons] ~= nil then
							if viewIcons >= moSetGetOverlays.iconPreviewPDA.bounds[1] and viewIcons <= moSetGetOverlays.iconPreviewPDA.bounds[2] then
								local overlay = moSetGetOverlays.iconPreviewPDA.iconOverlay[viewIcons];
								moSetGetOverlays:setOverlay(self, overlay, iconClickTable[a][1]+distanceAppIconWidth, iconClickTable[a][3], math.abs(iconClickTable[a][2]-iconClickTable[a][1])-(distanceAppIconWidth), math.abs(iconClickTable[a][4]-iconClickTable[a][3])-(distanceAppIconHeight));
								if viewIcons == moSetGetOverlays.iconPreviewPDA.selectIcon then
									moSetGetOverlays:setOverlay(self, moSetGetOverlays.iconPreviewPDA.overlay[11], iconClickTable[a][1]+(distanceAppIconWidth/2), iconClickTable[a][3]-(distanceAppIconHeight/2), iconClickTable[a][2]-iconClickTable[a][1], iconClickTable[a][4]-iconClickTable[a][3]);
									moSetGetOverlays.iconPreviewPDA.overlay[11]:render();
									if moSetGetOverlays.iconPreviewPDA.infoTxt[1] ~= nil and string.len(moSetGetOverlays.iconPreviewPDA.infoTxt[1]) > 0 then
										setTextColor(unpack(moColors:getColor("mangenta", true, {0, 0, 0, 1})));
										setTextBold(true);
										renderText(moSetGetOverlays.iconPreviewPDA.overlay[7].x+moSetGetOverlays.iconPreviewPDA.overlay[7].width+(0.002), moSetGetOverlays.iconPreviewPDA.overlay[7].y+(moSetGetOverlays.iconPreviewPDA.overlay[7].height*2)+(0.002), optiSize, tostring(moSetGetOverlays.iconPreviewPDA.infoTxt[1]));
										renderText(moSetGetOverlays.iconPreviewPDA.overlay[7].x+moSetGetOverlays.iconPreviewPDA.overlay[7].width+(0.002), moSetGetOverlays.iconPreviewPDA.overlay[7].y+moSetGetOverlays.iconPreviewPDA.overlay[7].height+(0.002), optiSize, tostring(moSetGetOverlays.iconPreviewPDA.infoTxt[2]));
										setTextBold(false);
										setTextColor(1, 1, 1, 1);
									end;
								end;
								
								if overlay.iconTyp == 4 and overlay.typTable["typ4"] ~= nil and string.len(overlay.typTable["typ4"].txt) > 0 then
									setTextColor(unpack(moColors.intern["black"]));
									if overlay.typTable["typ4"].color ~= nil then setTextColor(unpack(moColors:getColor(overlay.typTable["typ4"].color, nil, {0,0,0,1})));end;
									local iconTxt = tostring(overlay.typTable["typ4"].txt);
									local optiSize = moSetGetExtras:optiHeightSize(self, overlay.height/2-(0.001), tostring(iconTxt), 0.015);
									if overlay.typTable["typ4"].size ~= nil then
										if optiSize > overlay.typTable["typ4"].size then optiSize = overlay.typTable["typ4"].size;end;
									end;
									if overlay.typTable["typ4"].bold ~= nil then
										setTextBold(overlay.typTable["typ4"].bold);
									end;
									--local txtHeight = getTextHeight(optiSize, tostring(iconTxt));
									setTextWrapWidth(overlay.width-(0.001));
									setTextLineBounds(0, 2);
									setTextAlignment(1);
									renderText(overlay.x+(overlay.width/2), overlay.y+(overlay.height/2)+0.001, optiSize, tostring(iconTxt))
									setTextAlignment(0);
									setTextWrapWidth(0);
									setTextLineBounds(0, 0);
									setTextColor(1, 1, 1, 1);
									setTextBold(false);
								end;								
								
								overlay:render();
								iconClickTable[a].position = viewIcons;
								moGeneralSettings.clickAreas.previewIcons[#moGeneralSettings.clickAreas.previewIcons+1] = iconClickTable[a];
								viewIcons = viewIcons+1;							
							end;						
						end;
					elseif iconClickTable[a].whatClick == "appPdaClose"  or iconClickTable[a].whatClick == "appPdaLineUp" or iconClickTable[a].whatClick == "appPdaLineDown" then
						moGeneralSettings.clickAreas.previewIcons[#moGeneralSettings.clickAreas.previewIcons+1] = iconClickTable[a];
					end;
				end;
			end;			
		end;		
	end;
end;