fillTypesAmountPrice = {};
fillTypesAmountPrice.sortBy = "Amount";

--needs module fillTypes,amount,greatDemand,sellingStationsSimple
--lineType 3/test
function fillTypesAmountPrice:load()
	if moFillTypes == nil or moFillTypes.values == nil or moFillTypes.values.fillTypes == nil then fillTypesAmountPrice.output = {};return;end;
	local lineTable = {lineTyp=3, txtScroll={leftRight=true,upDown=true}};	
	for a=1, #moFillTypes.values.fillTypes do
		if moFillTypes.values.fillTypes[a] ~= nil and moFillTypes.values.fillTypes[a].view then
			local fillTypes = moFillTypes.values.fillTypes[a];
			lineTable[#lineTable+1] = {};
			local isLineTable = lineTable[#lineTable];			
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 45;	--width prozent				
			--isLineTable.txt[1].clickCallback = 
			isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);
			local isGreatDemand = moFillTypes.values.greatDemand[fillTypes.index] ~= nil and moFillTypes.values.greatDemand[fillTypes.index].isRunning and moFillTypes.values.greatDemand[fillTypes.index].isValid;
			isLineTable.txt[1].bold = moModule.values.txtBold;
			--isLineTable.txt[1].difSize = 0.001;							
			local name = "";
			if moFillTypes.values.name then name = fillTypes.name;end;
			if moFillTypes.values.regName then
				if string.len(name) == 0 then name = fillTypes.regName;else name = name.. " (".. fillTypes.regName.. ")";end;
			end;
			if moFillTypes.values.index then
				if string.len(name) == 0 then name = fillTypes.index;else name = name.. " *".. fillTypes.index.. "*";end;
			end;
			isLineTable.txt[1].txt = tostring(name);
			isLineTable.name = name;
			----------------------------------------
			isLineTable.txt[2] = {};
			isLineTable.txt[2].width = 30; --width prozent
			--isLineTable.txt[2].clickCallback = 
			local amount = moFillTypes.values.amount[fillTypes.index];
			local isUpAlpha = true;			
			if amount ~= nil and type(amount) == "number" and amount <=0.8 then isLineTable.txt[1].color = moColors:getColor(moModule.values.txtNoAmountColor);isUpAlpha=false;end;
			if amount == nil then amount = 0;isLineTable.txt[1].color = moColors:getColor(moModule.values.txtNoAmountColor);isUpAlpha=false;end;
			isLineTable.txt[2].color = moColors:getColor(moModule.values.txtNoAmountColor);
			if isUpAlpha then isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);isLineTable.txt[2].color = moColors:getColor(moModule.values.txtAmountColor);end;			
			if isGreatDemand then isLineTable.txt[1].color = moColors:getColor(moModule.values.txtGreatDemandColor);end;
			
			isLineTable.txt[2].txt = string.format("%1.0f", "".. tostring(amount)); --g_i18n:formatNumber(foodGroupTable.fillLevel);
			isLineTable.txt[2].bold = moModule.values.txtBold;
			isLineTable.txt[2].txtPos = 1;
			isLineTable.amount = Utils.getNoNil(amount, 0);
			----------------------------------------
			isLineTable.txt[3] = {};
			isLineTable.txt[3].width = 25; --width prozent
			isLineTable.txt[3].clickCallback = fillTypesAmountPrice.returnLinePriceClick;
			local bestPrice = 0;
			local bestPrice1 = 0;local bestPrice1Station = "";
			local bestPrice2 = 0;local bestPrice2Station = "";
			local bestPrice3 = 0;local bestPrice3Station = "";
			local bestPrice4 = 0;local bestPrice4Station = "";			
			if moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index] ~= nil then
				bestPrice = Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][1][1], 0);
				bestPrice1 = g_i18n:formatMoney(Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][1][1], 0));
				bestPrice1Station = Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][1][2], "");
				if isGreatDemand and moFillTypes.values.greatDemand[fillTypes.index].stationName == bestPrice1Station then
					bestPrice1Station = bestPrice1Station.. " (".. moLanguageXml:getTxt("greatdemand", nil, "GreatDemand").. ")";
				end;
				if moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][2] ~= nil then				
					bestPrice2 = g_i18n:formatMoney(Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][2][1], 0));
					bestPrice2Station = Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][2][2], "");
					if isGreatDemand and moFillTypes.values.greatDemand[fillTypes.index].stationName == bestPrice2Station then
						bestPrice2Station = bestPrice2Station.. " (".. moLanguageXml:getTxt("greatdemand", nil, "GreatDemand").. ")";
					end;
				end;
				if moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][3] ~= nil then
					bestPrice3 = g_i18n:formatMoney(Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][3][1], 0));
					bestPrice3Station = Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][3][2], "");
					if isGreatDemand and moFillTypes.values.greatDemand[fillTypes.index].stationName == bestPrice3Station then
						bestPrice3Station = bestPrice3Station.. " (".. moLanguageXml:getTxt("greatdemand", nil, "GreatDemand").. ")";
					end;
				end;
				if moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][4] ~= nil then
					bestPrice4 = g_i18n:formatMoney(Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][4][1], 0));
					bestPrice4Station = Utils.getNoNil(moFillTypes.values.bestPrice[moFillTypes.values.fillTypes[a].index][4][2], "");
					if isGreatDemand and moFillTypes.values.greatDemand[fillTypes.index].stationName == bestPrice4Station then
						bestPrice4Station = bestPrice4Station.. " (".. moLanguageXml:getTxt("greatdemand", nil, "GreatDemand").. ")";
					end;
				end;
				isLineTable.txt[3].bestPriceStation1 = {bestPrice1, bestPrice1Station};
				isLineTable.txt[3].bestPriceStation2 = {bestPrice2, bestPrice2Station};
				isLineTable.txt[3].bestPriceStation3 = {bestPrice3, bestPrice3Station};
				isLineTable.txt[3].bestPriceStation4 = {bestPrice4, bestPrice4Station};
			end;
			isLineTable.txt[3].color = moColors:getColor(moModule.values.txtPriceColor);					
			if bestPrice <= 0 then isLineTable.txt[3].color = moColors:getColor(moModule.values.txtNoPriceColor);end;
			isLineTable.txt[3].txt = bestPrice1;
			isLineTable.txt[3].bold = moModule.values.txtBold;
			isLineTable.txt[3].difSize = 0.001;
			isLineTable.txt[3].txtPos = 2;
			isLineTable.price = Utils.getNoNil(bestPrice, 0);
		end;
	end;
	function comp(w1,w2)		
		if w1[fillTypesAmountPrice.sortBy:lower()] > w2[fillTypesAmountPrice.sortBy:lower()] then
			return true;
		end;				
	end;
	table.sort(lineTable, comp);	
	function setFirstLine()
		table.insert(lineTable, 1, {});
		local isLineTable = lineTable[1];
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = fillTypesAmountPrice.returnLineHelpIconClick;
		isLineTable.helpTxt = "Click Price for 1-4 BestPrice Stationes\nClick Sort By ... for SortType";
		isLineTable.txt = {};
		isLineTable.txt[1] = {clickCallback=fillTypesAmountPrice.returnLineSortByClick, color=moColors:getColor(moModule.values.txtTitleColor), txtPos=0, txt="Sort By ".. tostring(fillTypesAmountPrice.sortBy), bold=true};
		isLineTable.txt[1].settingsButtonL = {"buttonLeft", moColors.intern["green"], fillTypesAmountPrice.returnLineSortByClick};
	end;
	setFirstLine();
	fillTypesAmountPrice.output = lineTable;
end;

function fillTypesAmountPrice.returnLineSortByClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if fillTypesAmountPrice.sortBy == "Amount" then
			fillTypesAmountPrice.sortBy = "Name";
		elseif fillTypesAmountPrice.sortBy == "Name" then
			fillTypesAmountPrice.sortBy = "Price";
		elseif fillTypesAmountPrice.sortBy == "Price" then
			fillTypesAmountPrice.sortBy = "Amount";
		end;
	end;
end;

function fillTypesAmountPrice.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(fillTypesAmountPrice.output[args.line].helpTxt);
		end;
	end;
end;

function fillTypesAmountPrice.returnLinePriceClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.position ~= nil and args.line ~= nil then
			--if fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation ~= nil and string.len(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation) > 0 then 
			--	moSetGetOverlays.infoHelpBox.help.lsTimer = 4000;
			--	moSetGetOverlays.infoHelpBox.help.txt = "Best Price Stations:\n".. tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation);				
			--end;
			local bestPriceStation1 = "";
			local bestPriceStation2 = "";
			local bestPriceStation3 = "";
			local bestPriceStation4 = "";
			if fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation1 ~= nil and string.len(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation1[2]) > 0 then 
				bestPriceStation1 = tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation1[1]).. " ".. tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation1[2]);
			end;
			if fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation2 ~= nil and string.len(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation2[2]) > 0 then 
				bestPriceStation2 = tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation2[1]).. " ".. tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation2[2]);
			end;
			if fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation3 ~= nil and string.len(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation3[2]) > 0 then 
				bestPriceStation3 = tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation3[1]).. " ".. tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation3[2]);
			end;
			if fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation4 ~= nil and string.len(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation4[2]) > 0 then 
				bestPriceStation4 = tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation4[1]).. " ".. tostring(fillTypesAmountPrice.output[args.line].txt[args.position].bestPriceStation4[2]);
			end;
			if string.len(bestPriceStation1) > 0 then
				moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.help.txt = "Best Price Stations:  *".. tostring(fillTypesAmountPrice.output[args.line].txt[1].txt).. "*\n".. tostring(bestPriceStation1).. "\n".. tostring(bestPriceStation2).. "\n".. tostring(bestPriceStation3).. "\n".. tostring(bestPriceStation4);				
			end;
		end;
	end;
end;

function fillTypesAmountPrice.returnLineIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		
	end;
end;

function fillTypesAmountPrice.giveOutputTable()	
	moModule.active.fillTypes.isRunning = true;moModule.active.fillTypes.last = moModule.time.min+moModule.time.delay;
	moModule.active.greatDemand.isRunning = true;moModule.active.greatDemand.last = moModule.time.min+moModule.time.delay;
	--moModule.active.storages.isRunning = true;moModule.active.storages.last = moModule.time.min+moModule.time.delay;
	moModule.active.amount.isRunning = true;moModule.active.amount.last = moModule.time.min+moModule.time.delay;
	moModule.active.sellingStationsSimple.isRunning = true;moModule.active.sellingStationsSimple.last = moModule.time.min+moModule.time.delay;
	fillTypesAmountPrice:load();
	return fillTypesAmountPrice.output;	
end;

function fillTypesAmountPrice:reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	fillTypesAmountPrice:load();
end;

function fillTypesAmountPrice:generateCmd()
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };
	newCmdTable.cmdTable[1] = {
		cmdName = "fillTypesAmountPrice";
		displayName = "FillTypes/Amount/Price";		
		multiple = true;
		sortBy = "Module by Moh";
		infoTxt = "Zeigt die FillTypes mit der Füllmenge an und den Besten Preis + incl. Click Preis um die Station zu sehen";
		helpTxt = "FillTypes/Amount and Price in List";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		lineTyp = 3;
		typ = "output";
		action = fillTypesAmountPrice.giveOutputTable; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate fillTypesAmountPrice Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
end;

function fillTypesAmountPrice:setTxtColorAlpha(color, full)	
	local newColor = color;
	if full then newColor[4] = 1.0;else newColor[4] = 0.7;end;return newColor;
end;